

# Actions
<a name="API_Operations"></a>

The following actions are supported:
+  [CompleteSnapshot](API_CompleteSnapshot.md) 
+  [GetSnapshotBlock](API_GetSnapshotBlock.md) 
+  [ListChangedBlocks](API_ListChangedBlocks.md) 
+  [ListSnapshotBlocks](API_ListSnapshotBlocks.md) 
+  [PutSnapshotBlock](API_PutSnapshotBlock.md) 
+  [StartSnapshot](API_StartSnapshot.md) 

# CompleteSnapshot
<a name="API_CompleteSnapshot"></a>

Seals and completes the snapshot after all of the required blocks of data have been written to it. Completing the snapshot changes the status to `completed`. You cannot write new blocks to a snapshot after it has been completed.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_CompleteSnapshot_RequestSyntax"></a>

```
POST /snapshots/completion/snapshotId HTTP/1.1
x-amz-ChangedBlocksCount: ChangedBlocksCount
x-amz-Checksum: Checksum
x-amz-Checksum-Algorithm: ChecksumAlgorithm
x-amz-Checksum-Aggregation-Method: ChecksumAggregationMethod
```

## URI Request Parameters
<a name="API_CompleteSnapshot_RequestParameters"></a>

The request uses the following URI parameters.

 ** [ChangedBlocksCount](#API_CompleteSnapshot_RequestSyntax) **   <a name="ebs-CompleteSnapshot-request-ChangedBlocksCount"></a>
The number of blocks that were written to the snapshot.  
Valid Range: Minimum value of 0.  
Required: Yes

 ** [Checksum](#API_CompleteSnapshot_RequestSyntax) **   <a name="ebs-CompleteSnapshot-request-Checksum"></a>
An aggregated Base-64 SHA256 checksum based on the checksums of each written block.  
To generate the aggregated checksum using the linear aggregation method, arrange the checksums for each written block in ascending order of their block index, concatenate them to form a single string, and then generate the checksum on the entire string using the SHA256 algorithm.  
Length Constraints: Maximum length of 64.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [ChecksumAggregationMethod](#API_CompleteSnapshot_RequestSyntax) **   <a name="ebs-CompleteSnapshot-request-ChecksumAggregationMethod"></a>
The aggregation method used to generate the checksum. Currently, the only supported aggregation method is `LINEAR`.  
Length Constraints: Maximum length of 32.  
Pattern: `^[A-Za-z0-9]+$`   
Valid Values: `LINEAR` 

 ** [ChecksumAlgorithm](#API_CompleteSnapshot_RequestSyntax) **   <a name="ebs-CompleteSnapshot-request-ChecksumAlgorithm"></a>
The algorithm used to generate the checksum. Currently, the only supported algorithm is `SHA256`.  
Length Constraints: Maximum length of 32.  
Pattern: `^[A-Za-z0-9]+$`   
Valid Values: `SHA256` 

 ** [snapshotId](#API_CompleteSnapshot_RequestSyntax) **   <a name="ebs-CompleteSnapshot-request-uri-SnapshotId"></a>
The ID of the snapshot.  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: Yes

## Request Body
<a name="API_CompleteSnapshot_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_CompleteSnapshot_ResponseSyntax"></a>

```
HTTP/1.1 202
Content-type: application/json

{
   "Status": "string"
}
```

## Response Elements
<a name="API_CompleteSnapshot_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

 ** [Status](#API_CompleteSnapshot_ResponseSyntax) **   <a name="ebs-CompleteSnapshot-response-Status"></a>
The status of the snapshot.  
Type: String  
Length Constraints: Maximum length of 32.  
Valid Values: `completed | pending | error` 

## Errors
<a name="API_CompleteSnapshot_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_CompleteSnapshot_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/CompleteSnapshot) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/CompleteSnapshot) 

# GetSnapshotBlock
<a name="API_GetSnapshotBlock"></a>

Returns the data in a block in an Amazon Elastic Block Store snapshot.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_GetSnapshotBlock_RequestSyntax"></a>

```
GET /snapshots/snapshotId/blocks/blockIndex?blockToken=BlockToken HTTP/1.1
```

## URI Request Parameters
<a name="API_GetSnapshotBlock_RequestParameters"></a>

The request uses the following URI parameters.

 ** [blockIndex](#API_GetSnapshotBlock_RequestSyntax) **   <a name="ebs-GetSnapshotBlock-request-uri-BlockIndex"></a>
The block index of the block in which to read the data. A block index is a logical index in units of `512` KiB blocks. To identify the block index, divide the logical offset of the data in the logical volume by the block size (logical offset of data/`524288`). The logical offset of the data must be `512` KiB aligned.  
Valid Range: Minimum value of 0.  
Required: Yes

 ** [BlockToken](#API_GetSnapshotBlock_RequestSyntax) **   <a name="ebs-GetSnapshotBlock-request-uri-BlockToken"></a>
The block token of the block from which to get data. You can obtain the `BlockToken` by running the `ListChangedBlocks` or `ListSnapshotBlocks` operations.  
Length Constraints: Maximum length of 256.  
Pattern: `^[A-Za-z0-9+/=]+$`   
Required: Yes

 ** [snapshotId](#API_GetSnapshotBlock_RequestSyntax) **   <a name="ebs-GetSnapshotBlock-request-uri-SnapshotId"></a>
The ID of the snapshot containing the block from which to get data.  
If the specified snapshot is encrypted, you must have permission to use the KMS key that was used to encrypt the snapshot. For more information, see [ Using encryption](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapis-using-encryption.html) in the *Amazon Elastic Compute Cloud User Guide*.
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: Yes

## Request Body
<a name="API_GetSnapshotBlock_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetSnapshotBlock_ResponseSyntax"></a>

```
HTTP/1.1 200
x-amz-Data-Length: DataLength
x-amz-Checksum: Checksum
x-amz-Checksum-Algorithm: ChecksumAlgorithm

BlockData
```

## Response Elements
<a name="API_GetSnapshotBlock_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The response returns the following HTTP headers.

 ** [Checksum](#API_GetSnapshotBlock_ResponseSyntax) **   <a name="ebs-GetSnapshotBlock-response-Checksum"></a>
The checksum generated for the block, which is Base64 encoded.  
Length Constraints: Maximum length of 64.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [ChecksumAlgorithm](#API_GetSnapshotBlock_ResponseSyntax) **   <a name="ebs-GetSnapshotBlock-response-ChecksumAlgorithm"></a>
The algorithm used to generate the checksum for the block, such as SHA256.  
Length Constraints: Maximum length of 32.  
Pattern: `^[A-Za-z0-9]+$`   
Valid Values: `SHA256` 

 ** [DataLength](#API_GetSnapshotBlock_ResponseSyntax) **   <a name="ebs-GetSnapshotBlock-response-DataLength"></a>
The size of the data in the block.

The response returns the following as the HTTP body.

 ** [BlockData](#API_GetSnapshotBlock_ResponseSyntax) **   <a name="ebs-GetSnapshotBlock-response-BlockData"></a>
The data content of the block.

## Errors
<a name="API_GetSnapshotBlock_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetSnapshotBlock_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/GetSnapshotBlock) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/GetSnapshotBlock) 

# ListChangedBlocks
<a name="API_ListChangedBlocks"></a>

Returns information about the blocks that are different between two Amazon EBS snapshots of the same volume or between two snapshot copies of the same source snapshot.

If you specify snapshot copies, the API returns the difference only if the two snapshots are incremental copies. For more information, see [ Incremental snapshot copying](https://docs.aws.amazon.com/ebs/latest/userguide/ebs-copy-snapshot.html#ebs-incremental-copy).

You must have permissions to access the specified snapshots.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_ListChangedBlocks_RequestSyntax"></a>

```
GET /snapshots/secondSnapshotId/changedblocks?firstSnapshotId=FirstSnapshotId&maxResults=MaxResults&pageToken=NextToken&startingBlockIndex=StartingBlockIndex HTTP/1.1
```

## URI Request Parameters
<a name="API_ListChangedBlocks_RequestParameters"></a>

The request uses the following URI parameters.

 ** [FirstSnapshotId](#API_ListChangedBlocks_RequestSyntax) **   <a name="ebs-ListChangedBlocks-request-uri-FirstSnapshotId"></a>
The ID of the first snapshot to use for the comparison.  
The `FirstSnapshotID` parameter must be specified with a `SecondSnapshotId` parameter; otherwise, an error occurs.
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$` 

 ** [MaxResults](#API_ListChangedBlocks_RequestSyntax) **   <a name="ebs-ListChangedBlocks-request-uri-MaxResults"></a>
The maximum number of blocks to be returned by the request.  
Even if additional blocks can be retrieved from the snapshot, the request can return less blocks than **MaxResults** or an empty array of blocks.  
To retrieve the next set of blocks from the snapshot, make another request with the returned **NextToken** value. The value of **NextToken** is `null` when there are no more blocks to return.  
Valid Range: Minimum value of 100. Maximum value of 10000.

 ** [NextToken](#API_ListChangedBlocks_RequestSyntax) **   <a name="ebs-ListChangedBlocks-request-uri-NextToken"></a>
The token to request the next page of results.  
If you specify **NextToken**, then **StartingBlockIndex** is ignored.  
Length Constraints: Maximum length of 256.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [secondSnapshotId](#API_ListChangedBlocks_RequestSyntax) **   <a name="ebs-ListChangedBlocks-request-uri-SecondSnapshotId"></a>
The ID of the second snapshot to use for the comparison.  
The `SecondSnapshotId` parameter must be specified with a `FirstSnapshotID` parameter; otherwise, an error occurs.
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: Yes

 ** [StartingBlockIndex](#API_ListChangedBlocks_RequestSyntax) **   <a name="ebs-ListChangedBlocks-request-uri-StartingBlockIndex"></a>
The block index from which the comparison should start.  
The list in the response will start from this block index or the next valid block index in the snapshots.  
If you specify **NextToken**, then **StartingBlockIndex** is ignored.  
Valid Range: Minimum value of 0.

## Request Body
<a name="API_ListChangedBlocks_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListChangedBlocks_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "BlockSize": number,
   "ChangedBlocks": [ 
      { 
         "BlockIndex": number,
         "FirstBlockToken": "string",
         "SecondBlockToken": "string"
      }
   ],
   "ExpiryTime": number,
   "NextToken": "string",
   "VolumeSize": number
}
```

## Response Elements
<a name="API_ListChangedBlocks_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [BlockSize](#API_ListChangedBlocks_ResponseSyntax) **   <a name="ebs-ListChangedBlocks-response-BlockSize"></a>
The size of the blocks in the snapshot, in bytes.  
Type: Integer

 ** [ChangedBlocks](#API_ListChangedBlocks_ResponseSyntax) **   <a name="ebs-ListChangedBlocks-response-ChangedBlocks"></a>
An array of objects containing information about the changed blocks.  
Type: Array of [ChangedBlock](API_ChangedBlock.md) objects

 ** [ExpiryTime](#API_ListChangedBlocks_ResponseSyntax) **   <a name="ebs-ListChangedBlocks-response-ExpiryTime"></a>
The time when the `BlockToken` expires.  
Type: Timestamp

 ** [NextToken](#API_ListChangedBlocks_ResponseSyntax) **   <a name="ebs-ListChangedBlocks-response-NextToken"></a>
The token to use to retrieve the next page of results. This value is null when there are no more results to return.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [VolumeSize](#API_ListChangedBlocks_ResponseSyntax) **   <a name="ebs-ListChangedBlocks-response-VolumeSize"></a>
The size of the volume in GB.  
Type: Long  
Valid Range: Minimum value of 1.

## Errors
<a name="API_ListChangedBlocks_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_ListChangedBlocks_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/ListChangedBlocks) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/ListChangedBlocks) 

# ListSnapshotBlocks
<a name="API_ListSnapshotBlocks"></a>

Returns information about the blocks in an Amazon Elastic Block Store snapshot.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_ListSnapshotBlocks_RequestSyntax"></a>

```
GET /snapshots/snapshotId/blocks?maxResults=MaxResults&pageToken=NextToken&startingBlockIndex=StartingBlockIndex HTTP/1.1
```

## URI Request Parameters
<a name="API_ListSnapshotBlocks_RequestParameters"></a>

The request uses the following URI parameters.

 ** [MaxResults](#API_ListSnapshotBlocks_RequestSyntax) **   <a name="ebs-ListSnapshotBlocks-request-uri-MaxResults"></a>
The maximum number of blocks to be returned by the request.  
Even if additional blocks can be retrieved from the snapshot, the request can return less blocks than **MaxResults** or an empty array of blocks.  
To retrieve the next set of blocks from the snapshot, make another request with the returned **NextToken** value. The value of **NextToken** is `null` when there are no more blocks to return.  
Valid Range: Minimum value of 100. Maximum value of 10000.

 ** [NextToken](#API_ListSnapshotBlocks_RequestSyntax) **   <a name="ebs-ListSnapshotBlocks-request-uri-NextToken"></a>
The token to request the next page of results.  
If you specify **NextToken**, then **StartingBlockIndex** is ignored.  
Length Constraints: Maximum length of 256.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [snapshotId](#API_ListSnapshotBlocks_RequestSyntax) **   <a name="ebs-ListSnapshotBlocks-request-uri-SnapshotId"></a>
The ID of the snapshot from which to get block indexes and block tokens.  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: Yes

 ** [StartingBlockIndex](#API_ListSnapshotBlocks_RequestSyntax) **   <a name="ebs-ListSnapshotBlocks-request-uri-StartingBlockIndex"></a>
The block index from which the list should start. The list in the response will start from this block index or the next valid block index in the snapshot.  
If you specify **NextToken**, then **StartingBlockIndex** is ignored.  
Valid Range: Minimum value of 0.

## Request Body
<a name="API_ListSnapshotBlocks_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListSnapshotBlocks_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "Blocks": [ 
      { 
         "BlockIndex": number,
         "BlockToken": "string"
      }
   ],
   "BlockSize": number,
   "ExpiryTime": number,
   "NextToken": "string",
   "VolumeSize": number
}
```

## Response Elements
<a name="API_ListSnapshotBlocks_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [Blocks](#API_ListSnapshotBlocks_ResponseSyntax) **   <a name="ebs-ListSnapshotBlocks-response-Blocks"></a>
An array of objects containing information about the blocks.  
Type: Array of [Block](API_Block.md) objects

 ** [BlockSize](#API_ListSnapshotBlocks_ResponseSyntax) **   <a name="ebs-ListSnapshotBlocks-response-BlockSize"></a>
The size of the blocks in the snapshot, in bytes.  
Type: Integer

 ** [ExpiryTime](#API_ListSnapshotBlocks_ResponseSyntax) **   <a name="ebs-ListSnapshotBlocks-response-ExpiryTime"></a>
The time when the `BlockToken` expires.  
Type: Timestamp

 ** [NextToken](#API_ListSnapshotBlocks_ResponseSyntax) **   <a name="ebs-ListSnapshotBlocks-response-NextToken"></a>
The token to use to retrieve the next page of results. This value is null when there are no more results to return.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [VolumeSize](#API_ListSnapshotBlocks_ResponseSyntax) **   <a name="ebs-ListSnapshotBlocks-response-VolumeSize"></a>
The size of the volume in GB.  
Type: Long  
Valid Range: Minimum value of 1.

## Errors
<a name="API_ListSnapshotBlocks_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_ListSnapshotBlocks_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/ListSnapshotBlocks) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/ListSnapshotBlocks) 

# PutSnapshotBlock
<a name="API_PutSnapshotBlock"></a>

Writes a block of data to a snapshot. If the specified block contains data, the existing data is overwritten. The target snapshot must be in the `pending` state.

Data written to a snapshot must be aligned with 512-KiB sectors.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_PutSnapshotBlock_RequestSyntax"></a>

```
PUT /snapshots/snapshotId/blocks/blockIndex HTTP/1.1
x-amz-Data-Length: DataLength
x-amz-Progress: Progress
x-amz-Checksum: Checksum
x-amz-Checksum-Algorithm: ChecksumAlgorithm

BlockData
```

## URI Request Parameters
<a name="API_PutSnapshotBlock_RequestParameters"></a>

The request uses the following URI parameters.

 ** [blockIndex](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-uri-BlockIndex"></a>
The block index of the block in which to write the data. A block index is a logical index in units of `512` KiB blocks. To identify the block index, divide the logical offset of the data in the logical volume by the block size (logical offset of data/`524288`). The logical offset of the data must be `512` KiB aligned.  
Valid Range: Minimum value of 0.  
Required: Yes

 ** [Checksum](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-Checksum"></a>
A Base64-encoded SHA256 checksum of the data. Only SHA256 checksums are supported.  
Length Constraints: Maximum length of 64.  
Pattern: `^[A-Za-z0-9+/=]+$`   
Required: Yes

 ** [ChecksumAlgorithm](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-ChecksumAlgorithm"></a>
The algorithm used to generate the checksum. Currently, the only supported algorithm is `SHA256`.  
Length Constraints: Maximum length of 32.  
Pattern: `^[A-Za-z0-9]+$`   
Valid Values: `SHA256`   
Required: Yes

 ** [DataLength](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-DataLength"></a>
The size of the data to write to the block, in bytes. Currently, the only supported size is `524288` bytes.  
Valid values: `524288`   
Required: Yes

 ** [Progress](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-Progress"></a>
The progress of the write process, as a percentage.  
Valid Range: Minimum value of 0. Maximum value of 100.

 ** [snapshotId](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-uri-SnapshotId"></a>
The ID of the snapshot.  
If the specified snapshot is encrypted, you must have permission to use the KMS key that was used to encrypt the snapshot. For more information, see [ Using encryption](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapis-using-encryption.html) in the *Amazon Elastic Compute Cloud User Guide*..
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: Yes

## Request Body
<a name="API_PutSnapshotBlock_RequestBody"></a>

The request accepts the following binary data.

 ** [BlockData](#API_PutSnapshotBlock_RequestSyntax) **   <a name="ebs-PutSnapshotBlock-request-BlockData"></a>
The data to write to the block.  
The block data is not signed as part of the Signature Version 4 signing process. As a result, you must generate and provide a Base64-encoded SHA256 checksum for the block data using the **x-amz-Checksum** header. Also, you must specify the checksum algorithm using the **x-amz-Checksum-Algorithm** header. The checksum that you provide is part of the Signature Version 4 signing process. It is validated against a checksum generated by Amazon EBS to ensure the validity and authenticity of the data. If the checksums do not correspond, the request fails. For more information, see [ Using checksums with the EBS direct APIs](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-accessing-snapshot.html#ebsapis-using-checksums) in the *Amazon Elastic Compute Cloud User Guide*.  
Required: Yes

## Response Syntax
<a name="API_PutSnapshotBlock_ResponseSyntax"></a>

```
HTTP/1.1 201
x-amz-Checksum: Checksum
x-amz-Checksum-Algorithm: ChecksumAlgorithm
```

## Response Elements
<a name="API_PutSnapshotBlock_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The response returns the following HTTP headers.

 ** [Checksum](#API_PutSnapshotBlock_ResponseSyntax) **   <a name="ebs-PutSnapshotBlock-response-Checksum"></a>
The SHA256 checksum generated for the block data by Amazon EBS.  
Length Constraints: Maximum length of 64.  
Pattern: `^[A-Za-z0-9+/=]+$` 

 ** [ChecksumAlgorithm](#API_PutSnapshotBlock_ResponseSyntax) **   <a name="ebs-PutSnapshotBlock-response-ChecksumAlgorithm"></a>
The algorithm used by Amazon EBS to generate the checksum.  
Length Constraints: Maximum length of 32.  
Pattern: `^[A-Za-z0-9]+$`   
Valid Values: `SHA256` 

## Errors
<a name="API_PutSnapshotBlock_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_PutSnapshotBlock_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/PutSnapshotBlock) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/PutSnapshotBlock) 

# StartSnapshot
<a name="API_StartSnapshot"></a>

Creates a new Amazon EBS snapshot. The new snapshot enters the `pending` state after the request completes. 

After creating the snapshot, use [ PutSnapshotBlock](https://docs.aws.amazon.com/ebs/latest/APIReference/API_PutSnapshotBlock.html) to write blocks of data to the snapshot.

**Note**  
You should always retry requests that receive server (`5xx`) error responses, and `ThrottlingException` and `RequestThrottledException` client error responses. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html) in the *Amazon Elastic Compute Cloud User Guide*.

## Request Syntax
<a name="API_StartSnapshot_RequestSyntax"></a>

```
POST /snapshots HTTP/1.1
Content-type: application/json

{
   "ClientToken": "string",
   "Description": "string",
   "Encrypted": boolean,
   "KmsKeyArn": "string",
   "ParentSnapshotId": "string",
   "Tags": [ 
      { 
         "Key": "string",
         "Value": "string"
      }
   ],
   "Timeout": number,
   "VolumeSize": number
}
```

## URI Request Parameters
<a name="API_StartSnapshot_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_StartSnapshot_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [ClientToken](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-ClientToken"></a>
A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully. The subsequent retries with the same client token return the result from the original successful request and they have no additional effect.  
If you do not specify a client token, one is automatically generated by the AWS SDK.  
For more information, see [ Idempotency for StartSnapshot API](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-direct-api-idempotency.html) in the *Amazon Elastic Compute Cloud User Guide*.  
Type: String  
Length Constraints: Maximum length of 255.  
Pattern: `^[\S]+$`   
Required: No

 ** [Description](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-Description"></a>
A description for the snapshot.  
Type: String  
Length Constraints: Maximum length of 255.  
Pattern: `^[\S\s]+$`   
Required: No

 ** [Encrypted](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-Encrypted"></a>
Indicates whether to encrypt the snapshot.  
You can't specify **Encrypted** and ** ParentSnapshotId** in the same request. If you specify both parameters, the request fails with `ValidationException`.  
The encryption status of the snapshot depends on the values that you specify for **Encrypted**, **KmsKeyArn**, and **ParentSnapshotId**, and whether your AWS account is enabled for [ encryption by default](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default). For more information, see [ Using encryption](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapis-using-encryption.html) in the *Amazon Elastic Compute Cloud User Guide*.  
To create an encrypted snapshot, you must have permission to use the KMS key. For more information, see [ Permissions to use AWS Key Management Service keys](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapi-permissions.html#ebsapi-kms-permissions) in the *Amazon Elastic Compute Cloud User Guide*.
Type: Boolean  
Required: No

 ** [KmsKeyArn](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-KmsKeyArn"></a>
The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) key to be used to encrypt the snapshot.  
The encryption status of the snapshot depends on the values that you specify for **Encrypted**, **KmsKeyArn**, and **ParentSnapshotId**, and whether your AWS account is enabled for [ encryption by default](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default). For more information, see [ Using encryption](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapis-using-encryption.html) in the *Amazon Elastic Compute Cloud User Guide*.  
To create an encrypted snapshot, you must have permission to use the KMS key. For more information, see [ Permissions to use AWS Key Management Service keys](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapi-permissions.html#ebsapi-kms-permissions) in the *Amazon Elastic Compute Cloud User Guide*.
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws[a-z\-]*:kms:.*:[0-9]{12}:key/.*`   
Required: No

 ** [ParentSnapshotId](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-ParentSnapshotId"></a>
The ID of the parent snapshot. If there is no parent snapshot, or if you are creating the first snapshot for an on-premises volume, omit this parameter.  
You can't specify **ParentSnapshotId** and **Encrypted** in the same request. If you specify both parameters, the request fails with `ValidationException`.  
The encryption status of the snapshot depends on the values that you specify for **Encrypted**, **KmsKeyArn**, and **ParentSnapshotId**, and whether your AWS account is enabled for [ encryption by default](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EBSEncryption.html#encryption-by-default). For more information, see [ Using encryption](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapis-using-encryption.html) in the *Amazon Elastic Compute Cloud User Guide*.  
If you specify an encrypted parent snapshot, you must have permission to use the KMS key that was used to encrypt the parent snapshot. For more information, see [ Permissions to use AWS Key Management Service keys](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebsapi-permissions.html#ebsapi-kms-permissions) in the *Amazon Elastic Compute Cloud User Guide*.
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$`   
Required: No

 ** [Tags](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-Tags"></a>
The tags to apply to the snapshot.  
Type: Array of [Tag](API_Tag.md) objects  
Required: No

 ** [Timeout](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-Timeout"></a>
The amount of time (in minutes) after which the snapshot is automatically cancelled if:  
+ No blocks are written to the snapshot.
+ The snapshot is not completed after writing the last block of data.
If no value is specified, the timeout defaults to `60` minutes.  
Type: Integer  
Valid Range: Minimum value of 10. Maximum value of 4320.  
Required: No

 ** [VolumeSize](#API_StartSnapshot_RequestSyntax) **   <a name="ebs-StartSnapshot-request-VolumeSize"></a>
The size of the volume, in GiB. The maximum size is `65536` GiB (64 TiB).  
Type: Long  
Valid Range: Minimum value of 1.  
Required: Yes

## Response Syntax
<a name="API_StartSnapshot_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "BlockSize": number,
   "Description": "string",
   "KmsKeyArn": "string",
   "OwnerId": "string",
   "ParentSnapshotId": "string",
   "SnapshotId": "string",
   "SseType": "string",
   "StartTime": number,
   "Status": "string",
   "Tags": [ 
      { 
         "Key": "string",
         "Value": "string"
      }
   ],
   "VolumeSize": number
}
```

## Response Elements
<a name="API_StartSnapshot_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [BlockSize](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-BlockSize"></a>
The size of the blocks in the snapshot, in bytes.  
Type: Integer

 ** [Description](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-Description"></a>
The description of the snapshot.  
Type: String  
Length Constraints: Maximum length of 255.  
Pattern: `^[\S\s]+$` 

 ** [KmsKeyArn](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-KmsKeyArn"></a>
The Amazon Resource Name (ARN) of the AWS Key Management Service (AWS KMS) key used to encrypt the snapshot.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `arn:aws[a-z\-]*:kms:.*:[0-9]{12}:key/.*` 

 ** [OwnerId](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-OwnerId"></a>
The AWS account ID of the snapshot owner.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 24.  
Pattern: `\S+` 

 ** [ParentSnapshotId](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-ParentSnapshotId"></a>
The ID of the parent snapshot.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$` 

 ** [SnapshotId](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-SnapshotId"></a>
The ID of the snapshot.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Pattern: `^snap-[0-9a-f]+$` 

 ** [SseType](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-SseType"></a>
Reserved for future use.  
Type: String  
Valid Values: `sse-ebs | sse-kms | none` 

 ** [StartTime](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-StartTime"></a>
The timestamp when the snapshot was created.  
Type: Timestamp

 ** [Status](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-Status"></a>
The status of the snapshot.  
Type: String  
Length Constraints: Maximum length of 32.  
Valid Values: `completed | pending | error` 

 ** [Tags](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-Tags"></a>
The tags applied to the snapshot. You can specify up to 50 tags per snapshot. For more information, see [ Tagging your Amazon EC2 resources](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Using_Tags.html) in the *Amazon Elastic Compute Cloud User Guide*.  
Type: Array of [Tag](API_Tag.md) objects

 ** [VolumeSize](#API_StartSnapshot_ResponseSyntax) **   <a name="ebs-StartSnapshot-response-VolumeSize"></a>
The size of the volume, in GiB.  
Type: Long  
Valid Range: Minimum value of 1.

## Errors
<a name="API_StartSnapshot_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 403

 ** ConcurrentLimitExceededException **   
You have reached the limit for concurrent API requests. For more information, see [Optimizing performance of the EBS direct APIs](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ebs-accessing-snapshot.html#ebsapi-performance) in the *Amazon Elastic Compute Cloud User Guide*.  
HTTP Status Code: 400

 ** ConflictException **   
The request uses the same client token as a previous, but non-identical request.  
HTTP Status Code: 409

 ** InternalServerException **   
An internal error has occurred. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).  
HTTP Status Code: 500

 ** RequestThrottledException **   
The number of API requests has exceeded the maximum allowed API request throttling limit for the snapshot. For more information see [Error retries](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/error-retries.html).    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
Your current service quotas do not allow you to perform this action.    
 ** Reason **   
The reason for the exception.
HTTP Status Code: 402

 ** ValidationException **   
The input fails to satisfy the constraints of the EBS direct APIs.    
 ** Reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_StartSnapshot_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ebs-2019-11-02/StartSnapshot) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ebs-2019-11-02/StartSnapshot) 